<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\master_worker;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\master_worker\BankAccount;
use app\common\model\master_worker\MasterWorker;
use app\common\model\master_worker\MasterWorkerAgree;
use app\common\lists\ListsSearchInterface;
use app\common\model\master_worker\MasterWorkerInfo;


/**
 * MasterWorkerExamineLists列表
 * Class MasterWorkerExamineLogic
 * @package app\adminapi\listsmaster_worker
 */
class MasterWorkerExamineLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function setSearch(): array
    {
        return [
        ];
    }
    public function queryWhere(){
        $where = [];
        if(isset($this->params['audit_state']) && $this->params['audit_state']!=''){
            $ids = MasterWorker::where('audit_state',$this->params['audit_state'])->column('id');
            $where[] = ['id', 'IN', $ids?:[0]];
            //dd($ids);
        }
        /*$infoWorkerIds = MasterWorkerInfo::where('audit_state',0)->column('worker_id');
        $bankWorkerIds = BankAccount::where('audit_state',0)->column('worker_id');
        $agreeWorkerIds = MasterWorkerAgree::where('audit_state',0)->column('worker_id');
        $ids = array_merge($infoWorkerIds,$bankWorkerIds,$agreeWorkerIds);*/
        if(isset($this->params['real_name']) && !empty($this->params['real_name'])){
            $where[] = ['id', 'IN', MasterWorker::where([['real_name', 'like', "%{$this->params['real_name']}%"]])->column('id')?:[0]];
        }
        if(isset($this->params['nickname']) && !empty($this->params['nickname'])){
            $where[] = ['id', 'IN', MasterWorker::where([['nickname', 'like', "%{$this->params['nickname']}%"]])->column('id')?:[0]];
        }
        if(isset($this->params['account']) && !empty($this->params['account'])){
            $where[] = ['id', 'IN', MasterWorker::where([['account', 'like', "%{$this->params['account']}%"]])->column('id')?:[0]];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function lists(): array
    {
        $queryWhere = $this->queryWhere();
        return MasterWorker::with(['workerInfo','workerAgree','bankAccount'])->where($this->searchWhere)->where($queryWhere)
            ->field(['*'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function count(): int
    {
        $queryWhere = $this->queryWhere();
        return MasterWorker::where($this->searchWhere)->where($queryWhere)->count();
    }

}